/**
 ** sparkyarpMainTaskCodels.cc
 **
 ** Codels called by execution task sparkyarpMainTask
 **
 ** Author:  Akin Sisbot
 ** Date: 
 **
 **/

#include <iostream>
#include <portLib.h>
#include <stdlib.h>

#include "server/sparkyarpHeader.h"

#include "yarp/os/all.h"

#include "EgoSphereClient.h"
#include "opdbAccessClient.h"


using namespace std;
using namespace yarp;
using namespace yarp::os;

static POSTER_ID gBboxPoster_ID;

BufferedPort<Bottle> *robotPort;

Network yarpNet;

EgoSphereClient egoClient;
opdbAccessClient opdbClient;


void cart2Matrix(SPARK_POS_MATRIX *M, double Tx, double Ty, double Tz,
		 double Rx, double Ry, double Rz)
{
  double Sx = sin(Rx);
  double Cx = cos(Rx);
  double Sy = sin(Ry);
  double Cy = cos(Ry);
  double Sz = sin(Rz);
  double Cz = cos(Rz);
  double SyCz = Sy*Cz;
  double SySz = Sy*Sz;

  M->nx = Cy*Cz;
  M->ox = Sx*SyCz - Cx*Sz;
  M->ax = Cx*SyCz + Sx*Sz;
  M->px = Tx;

  M->ny = Cy*Sz;
  M->oy = Sx*SySz + Cx*Cz;
  M->ay = Cx*SySz - Sx*Cz;
  M->py = Ty;

  M->nz = -Sy;
  M->oz = Sx*Cy;
  M->az = Cx*Cy;
  M->pz = Tz;
}


STATUS
sparkyarpMainTaskInit(int *report)
{
  /*  Network::init();
      ourPort = new BufferedPort<Bottle>();
      ourPort->open("SPARK_PORT");
      // Network::connect("server","SPARK_PORT");
      ourPort->setStrict(false);  */
  return OK;
}

STATUS
sparkyarpMainTaskPerm(int *report)
{
 
  /*-------------- CREATE AND SEND AND OBJECT ----------------*/
  /*  chris::interfaces::objectState egoObj;
  static double rot = 0;
  int egoID;
  egoObj.clear();
  egoObj.r = 1;
  egoObj.elevation = 0;
  if(rot > 360)
  rot = 0;
  else
  rot += 10;
  egoObj.azimuth = rot;
  egoObj.objectID = 8000;
  egoObj.visible = 1;
  egoID = egoClient.addObject(egoObj);
  printf("EGOID IS %d\n",egoID);   */
  /* -------------------------------------------------------*/

  /*------------------READ AN OBJECT------------------------*/
  /*chris::interfaces::objectState egoObj;
  egoClient.getObject(1, egoObj);
  printf("Object %d with azimuth %f\n",egoObj.objectID, egoObj.azimuth); */
  /* -------------------------------------------------------*/

  /* -------------OLD CODE---------------- */
  /*  if(ourPort == NULL) {
      printf("PORT IS NULL\n");
      return ETHER;
      }
      Bottle* b = ourPort->read(false);
      if(b == NULL) {
      printf("NO DATA IS READ\n");
      return ETHER;
      }
      else {    
      if(b->size() == 2) {
      printf("RECEIVED %f %f\n", b->get(0).asDouble(), b->get(1).asDouble());
      }
      }  */
  /* ------------------------------------- */
  return OK;
}

/* sparkyarpInitMain  -  codel EXEC of Init
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkyarpInitMain(int *report)
{
  if(egoClient.open("/chris/sparkyarp/ego:rpc","/chris/egosphere/rpc")){
    printf("Connected to YARP-Egosphere\n");
    *report = OK;
  }
  else {
    printf("Unable to connect to YARP Server\n");
    *report = S_sparkyarp_YARP_EGOSPHERE_NOT_FOUND;
  }
  
  if(opdbClient.open("/chris/sparkyarp/opdb:rpc","/opdb/rpc")){
    printf("Connected to YARP-OPDB\n");
    *report = OK;
  }
  else {
    printf("Unable to connect to YARP Server\n");
    *report = S_sparkyarp_YARP_OPDB_NOT_FOUND;
  }

  SDI_F->bodyPartList.humanNb = 0;
  
  return ETHER;
}

/* sparkyarpRegisterObjectsStart  -  codel START of RegisterObjects
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkyarpRegisterObjectsStart(SPARKYARP_BBPOSTER *bbPoster, int *report)
{
  if(posterFind(bbPoster->name, &gBboxPoster_ID)==ERROR) {
    *report = S_sparkyarp_POSTER_NOT_FOUND;
    return ETHER;
  } 
  return EXEC;
}


/* sparkyarpRegisterObjectsMain  -  codel EXEC of RegisterObjects
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkyarpRegisterObjectsMain(SPARKYARP_BBPOSTER *bbPoster, int *report)
{
  SPARK_BOUNDING_BOXES boxes;
  int i;
  int objectID;
  int res;
  
  if(posterRead(gBboxPoster_ID,0, &boxes, sizeof(boxes)) != sizeof(boxes)) {
    *report = S_sparkyarp_POSTER_NOT_READ;
    return ETHER;
  }
  
// SEND THE BOUNDINGBOXES TO OPDB
  
  for(i=0; i<boxes.robotNb; i++) {
    if(!strcasestr(boxes.bbox[i].name.name, "ROBOT") && !strcasestr(boxes.bbox[i].name.name, "VISBALL")) {
      res = opdbClient.setObject(boxes.bbox[i].name.name, 8000, 8999, boxes.bbox[i].x, boxes.bbox[i].y,  boxes.bbox[i].z,  objectID);
      if(res == CHRIS_FAILED)
	printf("Warning, %s cannot be registered to OPDB\n",boxes.bbox[i].name.name);
    }
  }
  
  return ETHER;
}


/* sparkyarpGetObjectsStart  -  codel START of GetObjectsPos
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkyarpGetObjectsStart(int *report)
{
  return EXEC;
}


/* sparkyarpGetObjectsMain  -  codel EXEC of GetObjectsPos
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkyarpGetObjectsMain(int *report)
{
  chris::interfaces::objectState egoObj;
  int object_nb;
  string object_label;
  int i, j;
  double x,y,z,rx,ry,rz;
  char human_obj[20];
  char human_name[20];
  char *obj_name;
  char nouse[20];
  SPARK_6D_COORD *coord;

  object_nb = egoClient.getNumberOfObjects();
  
  SDI_F->objectArray.nbObjects = 0;
  SDI_F->bodyPartList.humanNb = 0;

  for(i=0; i<object_nb; i++) {
  
    egoClient.getObject(i, egoObj);
    
    if(opdbClient.getObjectLabel(egoObj.objectID, object_label) == CHRIS_OK) {
      // Now we have the label of the object. Label == Spark Name
      obj_name = (char*)object_label.c_str();

      // printf("READ OBJECT %s and visibility is %d\n",obj_name, egoObj.visible );
    
      if(strcasestr(obj_name, "HUMAN")) { //if that's a human
	printf("HUMAN OBJ DETECTED. NAME: %s\n", obj_name);

	//sscanf(obj_name, "%s\.%s\.%s\n", human_name, human_obj, nouse);

	//human_obj = strcspn(obj_name, '.');
	j = 0;
	while(obj_name[j]!='.') {
	  human_name[j] = obj_name[j];
	  j++;
	}
	human_name[j]='\0';

	printf("HUMAN NAME %s\n", human_name);

	for(j=0; j<SDI_F->bodyPartList.humanNb; j++) { //Check if we already have that human
	  if(!strcmp(SDI_F->bodyPartList.human[j].name.name, human_name)) {
	    printf("Already have the human\n");
	    break;
	  }
	}
	coord = NULL;
	
	if(strstr(obj_name, "head")) {
	  SDI_F->bodyPartList.human[j].headAv = 1;
	  coord = &SDI_F->bodyPartList.human[j].head;
	}
	else {
	  if(strstr(obj_name, "torso")) {
	    SDI_F->bodyPartList.human[j].torsoAv = 1;
	    coord = &SDI_F->bodyPartList.human[j].torso;
	  }
	  else {
	    if(strstr(obj_name, "lefthand")) {
	      SDI_F->bodyPartList.human[j].leftHandAv = 1;
	      coord = &SDI_F->bodyPartList.human[j].leftHand;
	    }
	    else {
	      if(strstr(obj_name, "righthand")) {
		SDI_F->bodyPartList.human[j].rightHandAv = 1;
		coord = &SDI_F->bodyPartList.human[j].rightHand;
	      }
	      else {
		if(strstr(obj_name, "gaze")) {
		  SDI_F->bodyPartList.human[j].gazeAv = 1;
		  coord = &SDI_F->bodyPartList.human[j].gaze;
		}
	      }
	    }
	  }
	}
	if(coord!=NULL) {
	  egoObj.getCartesianPosition(coord->x, coord->y, coord->z);
	  coord->yaw =  EGO_DEGREES_TO_RAD(egoObj.xrot);
	  coord->pitch = EGO_DEGREES_TO_RAD(egoObj.yrot);
	  coord->roll = EGO_DEGREES_TO_RAD(egoObj.zrot);
	}
	else {
	  printf("body part %s is not defined\n", human_obj);
	}
	
	SDI_F->bodyPartList.human[j].available = 1;
	
	if(j==SDI_F->bodyPartList.humanNb){
	  strcpy(SDI_F->bodyPartList.human[j].name.name, human_name);
	  SDI_F->bodyPartList.humanNb++;
	}
      }
      else { // NOT HUMAN
	strcpy(SDI_F->objectArray.objects[i].name.name, object_label.c_str());
	SDI_F->objectArray.objects[i].visible = egoObj.visible;
      
	egoObj.getCartesianPosition(x,y,z);
	rx = EGO_DEGREES_TO_RAD(egoObj.xrot);
	ry = EGO_DEGREES_TO_RAD(egoObj.yrot);
	rz = EGO_DEGREES_TO_RAD(egoObj.zrot);
	SDI_F->objectArray.objects[i].tacq_usec = time(0);
      
	if(abs(x-SDI_F->objectArray.objects[i].absPosMatrix.px)>0.005 ||
	   abs(y-SDI_F->objectArray.objects[i].absPosMatrix.py)>0.005 ||
	   abs(z-SDI_F->objectArray.objects[i].absPosMatrix.pz)>0.005) {
	  SDI_F->objectArray.objects[i].motion = OBJ_MOVING;
	}
	else {
	  SDI_F->objectArray.objects[i].motion = OBJ_STATIC;
	}	  

	cart2Matrix(&SDI_F->objectArray.objects[i].absPosMatrix, x, y, z, rx, ry, rz); 
      
	SDI_F->objectArray.nbObjects++;
      }
    }
    else {
      printf("Cannot find objet %d in opdb\n",egoObj.objectID);
    }
  }
  
  return EXEC;
}



/* sparkyarpGetRobotsStart  -  codel START of GetRobots
   Returns:  START EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkyarpGetRobotsStart(int *report)
{
  int i;

  robotPort = new BufferedPort<Bottle>();
  robotPort->open("/chris/sparkyarp/robotconfig");
  robotPort->setStrict(false); 
  
  for(i=0; i<6; i++) {
    SDI_F->robotConfig.dof[i] = 0;
  }
    
  return EXEC;
}


/* sparkyarpGetRobotsMain  -  codel EXEC of GetRobots
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkyarpGetRobotsMain(int *report)
{
  Bottle *basePt, *configPt;
  int i, j;

  if(robotPort == NULL) {
    printf("Robot port not exists\n");
    return ETHER;
  }
  
  Bottle* b = robotPort->read(false);
  if(b == NULL) {
    //printf("NO DATA IS READ FROM ROBOT PORT\n");
    return EXEC;
  }
  else {
    if(b->size() == 3) {
      basePt = b->get(1).asList(); 
      configPt = b->get(2).asList();    
      
      if(basePt->size() == 6) {
	
	for(i=6, j=0; i<9; i++, j++) {
	  SDI_F->robotConfig.dof[i] = basePt->get(j).asDouble();
	}
      	for(i=9, j; i<12; i++, j++) {
	  SDI_F->robotConfig.dof[i] = EGO_DEGREES_TO_RAD(basePt->get(j).asDouble());
	}
	for(i, j=0; i<configPt->size()+12; i++, j++) {
	  SDI_F->robotConfig.dof[i] = EGO_DEGREES_TO_RAD(configPt->get(j).asDouble());
	}
	SDI_F->robotConfig.dofNb = i;
      }
      else {
	printf("Robot config base bottle size mismatch\n");	
      }
    }
    else {
      printf("Robot config bottle size mismatch\n");
    } 
  }
  
  return EXEC;
}


/* sparkyarpGetRobotsEnd  -  codel END of GetRobots
   Returns:  END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkyarpGetRobotsEnd(int *report)
{
  robotPort->close();
  return ETHER;
}


/* sparkyarpGetRobotsInter  -  codel INTER of GetRobots
   Returns:  INTER ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
sparkyarpGetRobotsInter(int *report)
{
  robotPort->close();
  return ETHER;
}

